<template>
  <Chart type="bar" :width="width" :height="height" :data="data" :options="options" />
</template>

<script setup>
  import {
    ref,
    onMounted
  } from "vue";
  import {
    computed
  } from "vue";
  import {
    useDarkModeStore
  } from "@/stores/dark-mode";
  import {
    useColorSchemeStore
  } from "@/stores/color-scheme";
  import {
    colors
  } from "@/utils/colors";
  import axios from "axios"

  const url = "http://localhost:3030/v1/dashboard"
  // const url = "http://10.175.11.75:82/v1/dashboard"
  const props = defineProps({
    width: {
      type: Number,
      default: 0,
    },
    height: {
      type: Number,
      default: 0,
    },
  });

  const darkMode = computed(() => useDarkModeStore().darkMode);
  const colorScheme = computed(() => useColorSchemeStore().colorScheme);

  const succesGraphEvent = ref([])
  const failedGraphEvent = ref([])
  const getGraphEvent = async () => {
    const res = await axios.get(url + "/graph")
    succesGraphEvent.value = res.data.data[0].count
    failedGraphEvent.value = res.data.data[1].count
    // succesGraphEvent.value = res.data.data
  }

  onMounted(getGraphEvent)


  const data = computed(() => {
    return {
      labels: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sept", "Oct", "Nov", "Des"],
      datasets: [{
          label: "Success",
          barPercentage: 0.5,
          barThickness: 6,
          maxBarThickness: 8,
          minBarLength: 2,
          data: succesGraphEvent.value,
          backgroundColor: colorScheme.value ? colors.primary() : "",
        },
        {
          label: "Failed",
          barPercentage: 0.5,
          barThickness: 6,
          maxBarThickness: 8,
          minBarLength: 2,
          data: failedGraphEvent.value,
          backgroundColor: darkMode.value ?
            colors.darkmode["200"]() : colors.slate["300"](),
        },
      ],
    };
  });

  const options = computed(() => {
    return {
      legend: {
        labels: {
          fontColor: colors.slate["500"](0.8),
        },
      },
      scales: {
        xAxes: [{
          ticks: {
            fontSize: "12",
            fontColor: colors.slate["500"](0.8),
          },
          gridLines: {
            display: false,
          },
        }, ],
        yAxes: [{
          ticks: {
            fontSize: "12",
            fontColor: colors.slate["500"](0.8),
            callback: function (value) {
              return value;
            },
          },
          gridLines: {
            color: darkMode.value ?
              colors.slate["500"](0.3) : colors.slate["300"](),
            zeroLineColor: darkMode.value ?
              colors.slate["500"](0.3) : colors.slate["300"](),
            borderDash: [2, 2],
            zeroLineBorderDash: [2, 2],
            drawBorder: false,
          },
        }, ],
      },
    };
  });
</script>